'use strict';

const { Controller } = require('egg');

class HomeController extends Controller {
  async index() {
    const { ctx } = this;
    ctx.body = 'hi, egg';
  }

  async postmsg() {
    const { ctx, app } = this;

    console.log(ctx.request.body, '111111');
    const { id, msg } = ctx.request.body;
    if (!id) {
      ctx.body = {
        code: 0,
        success: true,
        data: ctx.request.body,
      };
      return;
    }

    const clients = app.io.sockets.sockets;
    // query中的id为 用户id  io可以直接emit
    Object.values(clients)?.map(io => {
      const index = id.indexOf(io?.handshake?.query?.id);
      if (Array.isArray(id) && index !== -1) {
        io.emit('message', msg);
      } else if (io?.handshake?.query?.id === id) {
        io.emit('message', msg);
      }
      return io;
    });

    ctx.body = {
      code: 0,
      success: true,
      data: ctx.request.body,
    };
  }
}

module.exports = HomeController;
